#if !defined RQBUTTON_H
#define RQBUTTON_H

#include <windows.h>
#include "rqfont.h"
#include "rqcontrol.h"
#include "rqtooltip.h"
#include "rqdefs.h"

class RQButton: public RQControl
{
protected:
    HWND handle;
    char *caption;

    void messageHandler(HWND, UINT, WPARAM, LPARAM);
    HWND getHandle() { return handle; }
    RQControl* getParent() { return parent; }

public:
    RQButton();
    RQButton(char const*);
    ~RQButton();

    // Button properties
    RQFont font;
    RQToolTip toolTip;
    void  setParent(RQControl&);
    void  setAlign(ALIGN);
    ALIGN getAlign();
    void  setCaption(char*);
    char const* getCaption();

    // Button events
    void (*onClick)(RQButton&);
    void (*onMouseMove)(int x, int y, int shifts, RQButton&);
};

#endif
