#if !defined RQLABEL_H
#define RQLABEL_H

#include <windows.h>
#include "rqfont.h"
#include "rqcontrol.h"
#include "rqcanvas.h"
#include "rqdefs.h"

class RQLabel: public RQControl
{
private:
    int color;

protected:
    HWND handle;
    char *caption;

    void messageHandler(HWND, UINT, WPARAM, LPARAM);
    HWND getHandle() { return handle; }
    RQControl* getParent() { return parent; }

public:
    RQLabel();
    RQLabel(char const*);
    ~RQLabel();

    // Label properties
    RQFont font;
    RQCanvas canvas;
    void setParent(RQControl&);
    void setCaption(char const*);
    void setColor(int);
    int  getColor() { return color; }
    char const* getCaption() { return caption; }
    void setTop(int16 y);
    void setLeft(int16 x);
    void setWidth(int16 w);
    void setHeight(int16 h);
};
#endif
